'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Email;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * @copyright   2016, Miles Johnson
                                                                                                                                                                                                                              * @license     https://opensource.org/licenses/MIT
                                                                                                                                                                                                                              * 
                                                                                                                                                                                                                              */

/*:: import type { EmailProps } from '../types';*/


function obfuscate(email /*: string*/) /*: string*/ {
  var scrambled = '';

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = email[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var char = _step.value;

      scrambled += '&#' + char.charCodeAt(0) + ';';
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return scrambled;
}

function Email(_ref) {
  var children = _ref.children;
  var _ref$obfuscateEmail = _ref.obfuscateEmail;
  var obfuscateEmail = _ref$obfuscateEmail === undefined ? false : _ref$obfuscateEmail;

  var props = _objectWithoutProperties(_ref, ['children', 'obfuscateEmail']);

  var email = children;
  var mailTo = 'mailto';

  if (obfuscateEmail) {
    email = obfuscate(email);
    mailTo = obfuscate(mailTo);
  }

  return _react2.default.createElement(
    _Link2.default,
    _extends({}, props, { href: mailTo + ':' + email }),
    email
  );
}

Email.propTypes = {
  children: _react.PropTypes.string.isRequired,
  obfuscateEmail: _react.PropTypes.bool,
  emailParts: _react.PropTypes.shape({
    username: _react.PropTypes.string,
    host: _react.PropTypes.string
  })
};