'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Hashtag;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * @copyright   2016, Miles Johnson
                                                                                                                                                                                                                              * @license     https://opensource.org/licenses/MIT
                                                                                                                                                                                                                              * 
                                                                                                                                                                                                                              */

/*:: import type { HashtagProps } from '../types';*/
function Hashtag(_ref) {
  var children = _ref.children;
  var hashtagUrl = _ref.hashtagUrl;
  var _ref$encodeHashtag = _ref.encodeHashtag;
  var encodeHashtag = _ref$encodeHashtag === undefined ? false : _ref$encodeHashtag;

  var props = _objectWithoutProperties(_ref, ['children', 'hashtagUrl', 'encodeHashtag']);

  var url = hashtagUrl || '{{hashtag}}';
  var hashtag = children;

  if (encodeHashtag) {
    hashtag = encodeURIComponent(hashtag);
  }

  return _react2.default.createElement(
    _Link2.default,
    _extends({}, props, { href: url.replace('{{hashtag}}', hashtag) }),
    children
  );
}

Hashtag.propTypes = {
  children: _react.PropTypes.string.isRequired,
  hashtagName: _react.PropTypes.string,
  hashtagUrl: _react.PropTypes.string,
  encodeHashtag: _react.PropTypes.bool
};