'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Url;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * @copyright   2016, Miles Johnson
                                                                                                                                                                                                                              * @license     https://opensource.org/licenses/MIT
                                                                                                                                                                                                                              * 
                                                                                                                                                                                                                              */

/*:: import type { UrlProps } from '../types';*/
function Url(_ref) {
  var children = _ref.children;

  var props = _objectWithoutProperties(_ref, ['children']);

  var url = children;

  if (!url.match(/^https?:\/\//)) {
    url = 'http://' + url;
  }

  return _react2.default.createElement(
    _Link2.default,
    _extends({}, props, { href: url }),
    children
  );
}

Url.propTypes = {
  children: _react.PropTypes.string.isRequired,
  urlParts: _react.PropTypes.shape({
    scheme: _react.PropTypes.string,
    auth: _react.PropTypes.string,
    host: _react.PropTypes.string,
    port: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
    path: _react.PropTypes.string,
    query: _react.PropTypes.string,
    fragment: _react.PropTypes.string
  })
};